package kr.co.icontrols.ilp300_700.admin.setting;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.View;
import android.widget.RelativeLayout;

import kr.co.icontrols.ilp300_700.MainActivity;
import kr.co.icontrols.ilp300_700.R;
import kr.co.icontrols.ilp300_700.global.Configure;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValKey;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.DataClasses.LineInfoTable;
import kr.co.icontrols.ilp300_700.global.DataClasses.POSITION;
import kr.co.icontrols.ilp300_700.global.Declare;
import kr.co.icontrols.ilp300_700.global.Enumeration.DATAINPUTSCREEN;
import kr.co.icontrols.ilp300_700.global.Enumeration.DATAINPUTSTEP;
import kr.co.icontrols.ilp300_700.global.Global;
import kr.co.icontrols.ilp300_700.global.ID;
import kr.co.icontrols.ilp300_700.rfreader.STDAccessKeyManager;
import kr.co.icontrols.wallpadsupport.WpadImageView;
import kr.co.icontrols.wallpadsupport.WpadScreen;
import kr.co.icontrols.wallpadsupport.WpadTextView;

public class AdminSet_Setting_LineInfo extends WpadScreen {

    String TAG = "AdminSet_Setting_LineInfo";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = true;   // true, false
    Context mContext;
    WpadImageView Image_Background;
    WpadTextView Text_Title;
    WpadTextView Text_Line_01_Item;
    WpadTextView Text_Line_02_Item;
    WpadTextView Text_Line_03_Item;
    WpadTextView Text_Line_04_Item;
    WpadTextView Text_Line_05_Item;
    WpadTextView Text_Line_01_Input;
    WpadTextView Text_Line_02_Input;
    WpadTextView Text_Line_03_Input;
    WpadTextView Text_Line_04_Input;
    WpadTextView Text_Line_05_Input;
    int TextColor_Normal = Color.WHITE;
    int TextColor_Highlight = Color.GREEN;
    int nFontSize_Instruction = 28;
    boolean bFontNonBold = false;
    boolean bFontBold = true;
    String strText_Title = "라인정보 설정";
    String strText_Line_01_Item = "동정보";
    String strText_Line_02_Item = "라인 개수";
    String strText_Line_03_Item = " 라인번호 [ 0 ]";
    String strText_Line_04_Item = "최저층";
    String strText_Line_05_Item = "최고층";
    String strText_Line_01_Input = "";   // 동정보
    String strText_Line_02_Input = "";   // 라인개수
    String strText_Line_03_Input = "";   // 라인번호
    String strText_Line_04_Input = "";   // 최저층
    String strText_Line_05_Input = "";   // 최고층
    int nTempLineCnt = 0;   // 화면용 라인개수
    int[] anTempLineName;   // 화면용 라인번호
    int[] anTempLineLow;   // 화면용 최저층
    int[] anTempLineHigh;   // 화면용 최고층
    int nPageNo = 0;   // 라인정보 입력화면 페이지 번호
    boolean bSetReady = false;   // 라인정보 세부 페이지 순환완료
    public AdminSet_Setting_LineInfo(Context context, RelativeLayout layout) {
        super(context, layout);
        try {
            LOG("------------------ [START - AdminSet_Setting_LineInfo] -------------------");

            mContext = context;
            Initialize();

            Image_Background = new WpadImageView(context, 0, Declare.DeviceInfo.getScreenSizeFullW(ConfigValue.DEVICE_MODELTYPE), Declare.DeviceInfo.getScreenSizeFullH(ConfigValue.DEVICE_MODELTYPE), R.drawable.bg_back, 0, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.IMAGES.BACKGROUND);
            ViewRegistration(layout, Image_Background, 0, 0);

            Text_Title = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.TITLE).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.TITLE).H, Gravity.CENTER, Color.WHITE, nFontSize_Instruction, bFontBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.TITLE);
            ViewRegistration(layout, Text_Title, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.TITLE).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.TITLE).Y);
            Text_Title.setText(strText_Title);

            Text_Line_01_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Item);
            ViewRegistration(layout, Text_Line_01_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Item).Y);
            Text_Line_01_Item.setText(strText_Line_01_Item);

            Text_Line_02_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Item);
            ViewRegistration(layout, Text_Line_02_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Item).Y);
            Text_Line_02_Item.setText(strText_Line_02_Item);

            Text_Line_03_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Item);
            ViewRegistration(layout, Text_Line_03_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Item).Y);
            Text_Line_03_Item.setText(strText_Line_03_Item);

            Text_Line_04_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Item);
            ViewRegistration(layout, Text_Line_04_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Item).Y);
            Text_Line_04_Item.setText(strText_Line_04_Item);

            Text_Line_05_Item = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Item).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Item).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Item);
            ViewRegistration(layout, Text_Line_05_Item, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Item).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Item).Y);
            Text_Line_05_Item.setText(strText_Line_05_Item);

            Text_Line_01_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Input);
            ViewRegistration(layout, Text_Line_01_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Input).Y);
            Text_Line_01_Input.setText("( " + strText_Line_01_Input + " )");

            Text_Line_02_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Input);
            ViewRegistration(layout, Text_Line_02_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Input).Y);
            Text_Line_02_Input.setText("[ " + strText_Line_02_Input + " ]");

            Text_Line_03_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Input);
            ViewRegistration(layout, Text_Line_03_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Input).Y);
            Text_Line_03_Input.setText("[ " + strText_Line_03_Input + " ]");

            Text_Line_04_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Input);
            ViewRegistration(layout, Text_Line_04_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Input).Y);
            Text_Line_04_Input.setText("[ " + strText_Line_04_Input + " ]");

            Text_Line_05_Input = new WpadTextView(context, false, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Input).W, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Input).H, Gravity.LEFT, Color.WHITE, nFontSize_Instruction, bFontNonBold, ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Input);
            ViewRegistration(layout, Text_Line_05_Input, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Input).X, getPosition(ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Input).Y);
            Text_Line_05_Input.setText("[ " + strText_Line_05_Input + " ]");

            UpdateScreen();

            ((MainActivity) mContext).setAutoScreenChange(ID.SCREENS.Main, MainActivity.nAdminScreenTimeout);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] AdminSet_Setting_LineInfo(...) : " + e);
            e.printStackTrace();
        }
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    protected void Initialize() {
        try {
            LOG("[Initialize] ===== START =====");
            Global.DataInputScreen = DATAINPUTSCREEN.DETAIL_01;
            Global.DataInputStep = DATAINPUTSTEP.INPUT_02;

            strText_Line_01_Input = ConfigValue.strDevice_Dong;
            strText_Line_02_Input = "0";
        } catch (Exception e) {
            Log.e(TAG, "[Exception] Initialize() : " + e);
            e.printStackTrace();
        }
    }

    @Override
    protected void onClose() {
        try {
            LOG("------------------ [onClose - AdminSet_Setting_LineInfo] -------------------");
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onClose() : " + e);
            e.printStackTrace();
        }
        super.onClose();
    }

    @Override
    protected void onBrReceive(Intent intent) {
        try {
            LOG("[onBrReceive] Intent : " + intent);
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onBrReceive(...) : " + e);
            e.printStackTrace();
        }
        super.onBrReceive(intent);
    }

    @Override
    protected void onKeyDown(int keyCode, KeyEvent event) {
        try {
//            LOG("[onKeyDown] keyCode [" + keyCode + "], event [" + event + "]");
            if (Declare.Button.NUMBER_00 <= keyCode && keyCode <= Declare.Button.NUMBER_09) {
                if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_01) {
                    if (Global.DataInputStep == DATAINPUTSTEP.INPUT_02) {
                        strText_Line_02_Input += keyCode - 7;

                        if (strText_Line_02_Input.length() > 2) {
                            strText_Line_02_Input = strText_Line_02_Input.substring(1);
                        }
                    }
                } else if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_02) {
                    if (Global.DataInputStep == DATAINPUTSTEP.INPUT_03) {
                        strText_Line_03_Input += keyCode - 7;

                        if (strText_Line_03_Input.length() > 2) {
                            strText_Line_03_Input = strText_Line_03_Input.substring(1);
                        }
                    } else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_04) {
                        strText_Line_04_Input += keyCode - 7;

                        if (strText_Line_04_Input.length() > 2) {
                            strText_Line_04_Input = strText_Line_04_Input.substring(1);
                        }
                    } else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_05) {
                        strText_Line_05_Input += keyCode - 7;

                        if (strText_Line_05_Input.length() > 2) {
                            strText_Line_05_Input = strText_Line_05_Input.substring(1);
                        }
                    }
                }
                UpdateScreen();
            } else if (keyCode == Declare.Button.STAR) {
                if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_02) {
                    if (Global.DataInputStep == DATAINPUTSTEP.INPUT_03) {
                        Global.DataInputStep = DATAINPUTSTEP.INPUT_04;
                    } else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_04) {
                        Global.DataInputStep = DATAINPUTSTEP.INPUT_05;
                    } else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_05) {
                        Global.DataInputStep = DATAINPUTSTEP.INPUT_03;
                    }
                }
                UpdateScreen();
            } else if (keyCode == Declare.Button.SHARP) {
                if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_02) {
                    if (checkValidityInputValues()) {
                        if (changeDetailScreen(nPageNo - 1, true, strText_Line_03_Input, strText_Line_04_Input, strText_Line_05_Input)) {
                            Global.DataInputStep = DATAINPUTSTEP.INPUT_03;
                        } else {
                            MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                        }
                    } else {
                        MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                        Global.DataInputStep = DATAINPUTSTEP.INPUT_03;
                    }
                    setDetailScreenValues();
                    UpdateScreen();
                }
            } else if (keyCode == Declare.Button.GUARD) {
                // 설정정보를 저장하는 기능을 정의한다.
                if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_01) {
                    // 입력된 라인개수를 임시저장합니다.
                    nTempLineCnt = Integer.parseInt(strText_Line_02_Input);
                    if (nTempLineCnt == 0) {
                        MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                        setLineInfo(nTempLineCnt, null, null, null);
                        super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                    } else {
                        Global.DataInputScreen = DATAINPUTSCREEN.DETAIL_02;
                        Global.DataInputStep = DATAINPUTSTEP.INPUT_03;
                        initLineDetails();
                        setDetailScreenValues();
                        UpdateScreen();
                    }
                } else if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_02) {
                    // 라인정보를 최종저장합니다.
                    if (!bSetReady) {
                        MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                        return;
                    }

                    if (setLineInfo(nTempLineCnt, anTempLineName, anTempLineLow, anTempLineHigh)) {
                        MainActivity.mSound.PlayMent_lobby(R.raw.setting);
                        STDAccessKeyManager.procLineInfoChanged();   // 세대카드정보를 갱신된 라인정보에 맞추어 갱신합니다.
                        super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                    } else {
                        MainActivity.mSound.PlayMent_lobby(R.raw.retryinput);
                        Initialize();
                        UpdateScreen();
                    }
                }
            } else if (keyCode == Declare.Button.CANCEL || keyCode == Declare.Button.TACT_CANCEL) {
                if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_01) {
                    super.setChangeScreen(ID.SCREENS.AdminSet_Setting);
                } else if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_02) {
                    strText_Line_02_Input = String.valueOf(nTempLineCnt);
                    Global.DataInputScreen = DATAINPUTSCREEN.DETAIL_01;
                    Global.DataInputStep = DATAINPUTSTEP.INPUT_02;
                    UpdateScreen();
                }
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onKeyDown(...) : " + e);
            e.printStackTrace();
        }
        super.onKeyDown(keyCode, event);
    }

    protected void UpdateVisibility() {
        try {
            LOG("[UpdateVisibility] ===== START =====");
            if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_01) {
                Text_Line_01_Item.setVisibility(View.VISIBLE);
                Text_Line_02_Item.setVisibility(View.VISIBLE);
                Text_Line_03_Item.setVisibility(View.INVISIBLE);
                Text_Line_04_Item.setVisibility(View.INVISIBLE);
                Text_Line_05_Item.setVisibility(View.INVISIBLE);

                Text_Line_01_Input.setVisibility(View.VISIBLE);
                Text_Line_02_Input.setVisibility(View.VISIBLE);
                Text_Line_03_Input.setVisibility(View.INVISIBLE);
                Text_Line_04_Input.setVisibility(View.INVISIBLE);
                Text_Line_05_Input.setVisibility(View.INVISIBLE);
            } else if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_02) {
                Text_Line_01_Item.setVisibility(View.INVISIBLE);
                Text_Line_02_Item.setVisibility(View.INVISIBLE);
                Text_Line_03_Item.setVisibility(View.VISIBLE);
                Text_Line_04_Item.setVisibility(View.VISIBLE);
                Text_Line_05_Item.setVisibility(View.VISIBLE);

                Text_Line_01_Input.setVisibility(View.INVISIBLE);
                Text_Line_02_Input.setVisibility(View.INVISIBLE);
                Text_Line_03_Input.setVisibility(View.VISIBLE);
                Text_Line_04_Input.setVisibility(View.VISIBLE);
                Text_Line_05_Input.setVisibility(View.VISIBLE);
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] UpdateVisibility() : " + e);
            e.printStackTrace();
        }
    }

    protected void UpdateScreen() {
        try {
//            LOG("[updateScreen] ===== START =====");
            if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_01) {
                UpdateVisibility();

                Text_Line_02_Input.setText("[ " + Integer.parseInt(strText_Line_02_Input) + " ]");

                Text_Line_01_Item.setTextColor(TextColor_Normal);
                Text_Line_02_Item.setTextColor(TextColor_Highlight);
                Text_Line_01_Input.setTextColor(TextColor_Normal);
                Text_Line_02_Input.setTextColor(TextColor_Highlight);
            } else if (Global.DataInputScreen == DATAINPUTSCREEN.DETAIL_02) {
                UpdateVisibility();
                Text_Line_03_Item.setText("순서 (" + nPageNo + ")");
                Text_Line_03_Input.setText("라인번호 [ " + Integer.parseInt(strText_Line_03_Input) + " ]");
                Text_Line_04_Input.setText("[ " + Integer.parseInt(strText_Line_04_Input) + " ]");
                Text_Line_05_Input.setText("[ " + Integer.parseInt(strText_Line_05_Input) + " ]");
                if (Global.DataInputStep == DATAINPUTSTEP.INPUT_03) {
                    Text_Line_03_Item.setTextColor(TextColor_Normal);
                    Text_Line_04_Item.setTextColor(TextColor_Normal);
                    Text_Line_05_Item.setTextColor(TextColor_Normal);
                    Text_Line_03_Input.setTextColor(TextColor_Highlight);
                    Text_Line_04_Input.setTextColor(TextColor_Normal);
                    Text_Line_05_Input.setTextColor(TextColor_Normal);
                } else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_04) {
                    Text_Line_03_Item.setTextColor(TextColor_Normal);
                    Text_Line_04_Item.setTextColor(TextColor_Highlight);
                    Text_Line_05_Item.setTextColor(TextColor_Normal);
                    Text_Line_03_Input.setTextColor(TextColor_Normal);
                    Text_Line_04_Input.setTextColor(TextColor_Highlight);
                    Text_Line_05_Input.setTextColor(TextColor_Normal);
                } else if (Global.DataInputStep == DATAINPUTSTEP.INPUT_05) {
                    Text_Line_03_Item.setTextColor(TextColor_Normal);
                    Text_Line_04_Item.setTextColor(TextColor_Normal);
                    Text_Line_05_Item.setTextColor(TextColor_Highlight);
                    Text_Line_03_Input.setTextColor(TextColor_Normal);
                    Text_Line_04_Input.setTextColor(TextColor_Normal);
                    Text_Line_05_Input.setTextColor(TextColor_Highlight);
                } else {
                    Text_Line_03_Item.setTextColor(TextColor_Normal);
                    Text_Line_04_Item.setTextColor(TextColor_Normal);
                    Text_Line_05_Item.setTextColor(TextColor_Normal);
                    Text_Line_03_Input.setTextColor(TextColor_Normal);
                    Text_Line_04_Input.setTextColor(TextColor_Normal);
                    Text_Line_05_Input.setTextColor(TextColor_Normal);
                }
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] updateScreen() : " + e);
            e.printStackTrace();
        }
    }

    private POSITION getPosition(int nID) {
//        LOG("[getPosition] ===== START =====");
        POSITION position = new POSITION();
        position.SetPosition(0, 0, 480, 272);
        try {
            switch (nID) {
                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.IMAGES.BACKGROUND:
                    position.SetPosition(0, 0, 480, 272);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.TITLE:
                    position.SetPosition(0, 24, 480, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Item:
                    position.SetPosition(50, 104, 145, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Item:
                    position.SetPosition(50, 154, 145, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Item:
                    position.SetPosition(30, 84, 165, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Item:
                    position.SetPosition(30, 134, 165, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Item:
                    position.SetPosition(30, 184, 165, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_01_Input:
                    position.SetPosition(205, 104, 205, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_02_Input:
                    position.SetPosition(205, 154, 205, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_03_Input:
                    position.SetPosition(205, 84, 245, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_04_Input:
                    position.SetPosition(205, 134, 245, 40);
                    return position;

                case ID.SCREENS.ADMINSET_SETTING_LINEINFO.ELEMENTS.TEXTS.LINE_05_Input:
                    position.SetPosition(205, 184, 245, 40);
                    return position;

                default:
                    return position;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] getPosition() : " + e);
            e.printStackTrace();
            return position;
        }
    }

    private void initLineDetails() {
        try {
            LOG("[initLineDetail] ===== START =====");
            bSetReady = false;
            nPageNo = 1;
            anTempLineName = new int[nTempLineCnt];
            anTempLineLow = new int[nTempLineCnt];
            anTempLineHigh = new int[nTempLineCnt];

            for (int i = 0; i < nTempLineCnt; i++) {
                anTempLineName[i] = 0;
                anTempLineLow[i] = 0;
                anTempLineHigh[i] = 0;
            }

//            int nCnt = 0;
//            if (ConfigValue.nLineCnt < nTempLineCnt) nCnt = ConfigValue.nLineCnt;
//            else nCnt = nTempLineCnt;
//
//            for (int i = 0; i < nCnt; i++) {
//                anTempLineName[i] = ConfigValue.LineInfo.aLineName[i];
//                anTempLineLow[i] = ConfigValue.LineInfo.aLineFloorLow[i];
//                anTempLineHigh[i] = ConfigValue.LineInfo.aLineFloorHigh[i];
//            }

        } catch (Exception e) {
            Log.e(TAG, "[Exception] initLineDetail() : " + e);
            e.printStackTrace();
        }
    }

    private boolean setDetailScreenValues() {
        try {
            LOG("[setDetailPageValues] ===== START =====");
            int index = nPageNo - 1;
            LOG("[setDetailPageValues] nPageNo [" + nPageNo + "], Name[" + index + "] = " + anTempLineName[index]);
            LOG("[setDetailPageValues] Low[" + index + "] = " + anTempLineLow[nPageNo - 1] + "], High[" + index + "] = " + anTempLineHigh[index]);
            strText_Line_03_Input = Integer.toString(anTempLineName[index]);
            strText_Line_04_Input = Integer.toString(anTempLineLow[index]);
            strText_Line_05_Input = Integer.toString(anTempLineHigh[index]);
            return true;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] setDetailPageValues() : " + e);
            e.printStackTrace();
            return false;
        }
    }

    private void PageUp() {
        try {
            if (nPageNo < nTempLineCnt) nPageNo++;
            else {
                bSetReady = true;
                nPageNo = 1;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] PageUp() : " + e);
            e.printStackTrace();
        }
    }

    private void PageDown() {
        try {
            if (nPageNo > 1) nPageNo--;
            else nPageNo = nTempLineCnt;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] PageDown() : " + e);
            e.printStackTrace();
        }
    }

    private boolean changeDetailScreen(int index, boolean bPageUp, String linename, String linelow, String linehigh) {
        try {
            LOG("[changeLineInfoInputScreen] index [" + index + "], bPageUp [" + bPageUp + "], linename [" + linename + "], linelow [" + linelow + "], linehigh [" + linehigh + "]");

            int name = Integer.parseInt(linename);
            int low = Integer.parseInt(linelow);
            int high = Integer.parseInt(linehigh);

            if (name < 1 || 99 < name) return false;
            if (low < 1 || 99 < low) return false;
            if (high < 1 || 99 < high) return false;

            if (!saveTempValues(index, linename, linelow, linehigh)) return false;

            if (bPageUp) PageUp();
            else PageDown();

            return setDetailScreenValues();
        } catch (Exception e) {
            Log.e(TAG, "[Exception] changeLineInfoInputScreen(index, linename, linelow, linehigh)");
            e.printStackTrace();
            return false;
        }
    }

    private boolean saveTempValues(int index, String linename, String linelow, String linehigh) {
        try {
            LOG("[saveTempValues] index [" + index + "], linename [" + linename + "], linelow [" + linelow + "], linehigh [" + linehigh + "]");
            anTempLineName[index] = Integer.parseInt(linename);
            anTempLineLow[index] = Integer.parseInt(linelow);
            anTempLineHigh[index] = Integer.parseInt(linehigh);
            return true;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] saveTempValues() : " + e);
            e.printStackTrace();
            return false;
        }
    }

    private boolean setLineInfo(int nCnt, int[] Name, int[] Low, int[] High) {
        try {
            String strResult = "ERROR";
            LineInfoTable mLineInfoTable = new LineInfoTable();
            mLineInfoTable.clearTable();
            for (int i = 0; i < nCnt; i++) {
                mLineInfoTable.addLineTable(Name[i], Low[i], High[i], null);
            }
            strResult = Configure.makeLineInfoString(mLineInfoTable);
            LOG("[setLineInfo] strResult = " + strResult);
            if (!strResult.matches(".*ERROR.*")) {
                ConfigValue.strLineInfo = strResult;
                if (!MainActivity.ConfigDBManager.setData(Declare.DBInfo.TABLE_NAME_CONFIG, ConfigValKey.LineInfo, ConfigValue.strLineInfo))
                    return false;
                return Configure.extractLineInfo(ConfigValue.strLineInfo);
            }
            return false;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] setLineInfo(nCnt, Name, Low, High)");
            e.printStackTrace();
            return false;
        }
    }

    private boolean checkValidityInputValues() {
        try {
            if (strText_Line_03_Input.equals("0") || strText_Line_04_Input.equals("0") || strText_Line_05_Input.equals("0"))
                return false;
            // 기 입력된 라인정보중에 동일한 라인정보 존재유무 확인
            for (int i = 0; i < anTempLineName.length; i++) {
                if (anTempLineName[i] == Integer.parseInt(strText_Line_03_Input)) {
                    if (nPageNo - 1 != i) {
                        LOG("[checkValidityInputValues] There is a same linename!! anTempLineName[" + i + "] = " + anTempLineName[i] + ", strText_Line_03_Input = " + strText_Line_03_Input);
                        return false;
                    }
                }
            }

            // 최저층 > 최고층인 경우 확인
            int low = Integer.parseInt(strText_Line_04_Input);
            int high = Integer.parseInt(strText_Line_05_Input);
            if (low > high) {
                LOG("[checkValidityInputValues] low > high!! strText_Line_04_Input = " + strText_Line_04_Input + ", strText_Line_05_Input = " + strText_Line_05_Input);
                return false;
            }
            return true;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] checkValidityInputValues() : " + e);
            e.printStackTrace();
            return false;
        }
    }


}